procedure xdir
parameters x_path
    //local aFiles, myrow
    local doit:=.T.
    
    if IsWindowDefined ( win_dir  )
       return
    endif  

    aFiles:=directory(x_path,"RHSAD")
    myrow := array(len(aFiles),5)

    DEFINE WINDOW win_dir ;
        AT 0,0 ;
        WIDTH 760 HEIGHT 400 ;
        NOMAXIMIZE ;
        NOMINIMIZE ;
        NOCAPTION ;
        TITLE 'Directory ' 

        readdir( x_path )
             
	     @ 10,10 GRID Grid_1 ;
		  WIDTH 700 ;
		  HEIGHT 280 ;
		  HEADERS {'Filename','Filesize','Date / Time ','Attribute','          '} ;
		  WIDTHS { 160,100,160,90,100 };
		  ITEMS myrow ;
		  VALUE 1 ;
        FONT 'Arial' BOLD SIZE 9; 
              ON DBLCLICK  pchange ( win_dir.Grid_1.value ) ;                               
		  TOOLTIP 'DoubleClick or Return to SELECT Fileentry' ;
                JUSTIFY { BROWSE_JTFY_LEFT,BROWSE_JTFY_RIGHT, BROWSE_JTFY_RIGHT }

                @ 300,10 TEXTBOX cFilename ;
                WIDTH  180 ;
                HEIGHT  30 ;
                FONT 'Arial' BOLD SIZE 12 

                @ 300,220 BUTTON myButton_1 ;
                CAPTION 'OK' ;
                WIDTH 80  ;
                HEIGHT 30  ;   
                FONT 'Arial' BOLD SIZE 12 ;             
                ACTION ( path:=alltrim(win_dir.cFileName.Value), ;
                                win_dir.Release )

                @ 300,330 BUTTON myButton_2 ;
                CAPTION 'CANCEL' ;
                WIDTH 80  ;
                HEIGHT 30  ;                
                FONT 'Arial' BOLD SIZE 12 ;
                ACTION ( msginfo('No File selected') , win_dir.Release )
        
     END WINDOW

     CENTER   WINDOW win_dir
     ACTIVATE WINDOW win_dir


return nil

function pchange
parameter nPos

local aTemp , myanz
local mychange:=' '
      
      xPos:=win_dir.Grid_1.value
  if rat('D',myrow[xPos,5]) > 0
     mychange:=ltrim( "\"+curdir()+"\"+myrow[xPos,1])
     if at('\\',mychange) > 0
        mychange:=substr(mychange,2,len(mychange))
     endif       
     dirchange( mychange )
 
     myanz:=readdir( c_open )
 //-------
     j:=win_dir.Grid_1.ItemCount
     do while j > 0
        win_dir.Grid_1.DeleteItem( j -- )
     enddo     
       win_dir.Grid_1.ItemCount := 0
  //------
     for j := 1 to myanz
         myrow[j,1] := aFiles[j,1]
         myrow[j,2] := str(aFiles[j,2])
         myrow[j,3] := dtoc(aFiles[j,3]) +'  '+aFiles[j,4]
         myrow[j,4] := aFiles[j,5]     

         if at('D',aFiles[j,5]) > 0
            myrow[j,2]:='    '
            myrow[j,5] := 'Directory'
         else
            myrow[j,5] := '         '
         endif      

         win_dir.Grid_1.AddItem( { myrow[j,1], myrow[j,2], myrow[j,3], myrow[j,4], myrow[j,5]  } )
         win_dir.Grid_1.Value := win_dir.Grid_1.ItemCount
     next
     win_dir.cFilename.Value:='       '
     win_dir.Grid_1.Value:=1
     win_dir.Grid_1.setfocus()
     win_dir.Grid_1.refresh()
     return nil
  else
     win_dir.cFilename.Value := alltrim( myrow[win_dir.Grid_1.value ,1] )
  endif

return nil

function change
parameters x_path,attr
private weida:=1

     if rat('D',attr) != 0
       if  at("..",x_path) != 0 .and. len(alltrim(x_path)) = 2
           dirchange(alltrim(x_path)+"\")      
       else
           dirchange( "\"+curdir()+"\"+x_path) 
           msginfo("Funktioniert "+ curdir() ) 
        endif
     else
        msginfo( "No Directory" )
     endif

return nil

//--------------------

function readdir
para my_path
local anzahl:=0
aFiles:=directory(my_path,"RHSAD")
myrow := array(len(aFiles),5)
anzahl:=len(aFiles)
       //--------
        for i:= 1 to len(aFiles)
           myrow[i,1] := aFiles[i,1]
           myrow[i,2] := str(aFiles[i,2])
           myrow[i,3] := dtoc(aFiles[i,3]) +'  '+aFiles[i,4]            
           myrow[i,4] := aFiles[i,5]
          if at('D',aFiles[i,5]) > 0
           myrow[i,2]:='     '
           myrow[i,5]:='Directory'
          else
           myrow[i,5]:=' '
          endif
        next
        //---------
return anzahl


function dlgopen
para open_mask
private open_ret

    if IsWindowDefined ( frmOpen  )
       return
    endif  

    DEFINE WINDOW frmOPEN ;
        AT 10,5 ;
        WIDTH 300 HEIGHT 100 ;
        NOMAXIMIZE ;
        NOMINIMIZE ;
        TITLE 'Select File to open' 

        @ 5,15 TEXTBOX  Text_k ; 
        WIDTH 50   ;
        HEIGHT 30  ;
        FONT "Verdana" SIZE 12 ;
        ON LOSTFOCUS  open_ret := alltrim( frmOPEN.Text_k.VALUE )                  

    END WINDOW

    CENTER WINDOW frmOPEN

    ACTIVATE WINDOW frmOPEN

return open_ret